/**
 * TeilklageRuecknahmeVerschiebenAction.java
 * eu.gronos.kostenrechner.view.panel (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.gebuehren;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.Action;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JTable;

import eu.gronos.kostenrechner.controller.BeschriebeneAktion;
import eu.gronos.kostenrechner.interfaces.GebuehrenTableTextfieldHandler;
import eu.gronos.kostenrechner.model.beschriftungen.LangBeschriftung;
import eu.gronos.kostenrechner.model.gebuehren.GebuehrenTableModel;
import eu.gronos.kostenrechner.view.gebuehren.TeilklageruecknahmePanel;

/**
 * Die {@link Action} entfernt den markierten Eintrag aus dieser Tabelle und
 * fügt ihn der jeweils anderen hinzu. Soll ins Kontextmenü.
 * {@link KeyEvent#VK_T}
 *
 */
public class TeilklageVerschiebenAction extends BeschriebeneAktion {
	protected final GebuehrenTableTextfieldHandler panel;
	private static final long serialVersionUID = 2748367225462023438L;
	// TeilklageruecknahmePanel

	/**
	 * Konstruktor.
	 * 
	 * @param panel        Verweis auf {@link TeilklageruecknahmePanel}
	 * @param beschriftung die {@link LangBeschriftung}, auch mit
	 *                     {@link Action#MNEMONIC_KEY}
	 */
	public TeilklageVerschiebenAction(GebuehrenTableTextfieldHandler panel, LangBeschriftung beschriftung) {
		super(beschriftung);
		this.panel = panel;
	}
	// TeilklageruecknahmePanel

//	public TeilklageVerschiebenAction(TeilklageruecknahmePanel panel, String name, String shortDescription,
//			int mnemonic, int mnemonic, String actionCommandKey) {, KeyEvent.VK_T
//		super(name, shortDescription, mnemonic, mnemonic, actionCommandKey);
//		this.panel = panel;
//	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		Object o = ae.getSource();
		if (!(o instanceof JMenuItem)) {
			return;
		}
		if (panel.getTableModel(TeilklageruecknahmePanel.TABLE_FTF_VORHER) == null
				|| panel.getTableModel(TeilklageruecknahmePanel.TABLE_FTF_NACHHER) == null) {
			return;
		}
		// Herausfinden, welche Tabelle ruft
		JPopupMenu popup = (JPopupMenu) ((JMenuItem) o).getParent();
		if (popup.getName().equals("17100")) {
			verschiebeGebuehrenTatbestand(panel.getTableModel(TeilklageruecknahmePanel.TABLE_FTF_VORHER),
					panel.getTableModel(TeilklageruecknahmePanel.TABLE_FTF_NACHHER),
					panel.getSelectedRow(TeilklageruecknahmePanel.TABLE_FTF_VORHER));
		}
		if (popup.getName().equals("17200")) {
			verschiebeGebuehrenTatbestand(panel.getTableModel(TeilklageruecknahmePanel.TABLE_FTF_NACHHER),
					panel.getTableModel(TeilklageruecknahmePanel.TABLE_FTF_VORHER),
					panel.getSelectedRow(TeilklageruecknahmePanel.TABLE_FTF_NACHHER));
		}
	}
// popup.getLabel() == TeilklageruecknahmePanel.VORHER_POPUPLABEL)
	// popup.getLabel() == TeilklageruecknahmePanel.NACHHER_POPUPLABEL
	// if (panel.tabVorher == null || panel.tabNachher == null
	// || !(panel.tabVorher.getModel() instanceof GebuehrenTableModel)
	// || !(panel.tabNachher.getModel() instanceof GebuehrenTableModel))
	// verschiebeGebuehrenTatbestand((GebuehrenTableModel)
	// panel.tabVorher.getModel(),
	// (GebuehrenTableModel) panel.tabNachher.getModel(),
	// panel.tabVorher.getSelectedRow());
	// verschiebeGebuehrenTatbestand((GebuehrenTableModel)
	// panel.tabNachher.getModel(),
	// (GebuehrenTableModel) panel.tabVorher.getModel(),
	// panel.tabNachher.getSelectedRow());

	/**
	 * Die Methode verschiebt einen Gebührentatbestand aus einer JTable in die
	 * andere.
	 * 
	 * 
	 * @param ausgang     das {@link GebuehrenTableModel}, aus der die Zeile
	 *                    gelöscht werden soll
	 * @param ziel        das {@link GebuehrenTableModel}, in die die Zeile
	 *                    verschoben werden soll
	 * @param selectedRow {@link JTable#getSelectedRow()} der Ausgangstabelle
	 */
	protected void verschiebeGebuehrenTatbestand(GebuehrenTableModel ausgang, GebuehrenTableModel ziel, int selectedRow) {
		if (ausgang == null || ziel == null || selectedRow < 0)
			return;
		ziel.addRow(ausgang.getRow(selectedRow));
		ausgang.removeRow(selectedRow);
	}

	/*
	 * GebuehrenTatbestandTableModel if (ausgang == null || ziel == null ||
	 * ausgang.getSelectedRow() < 0 || !(ausgang.getModel() instanceof
	 * GebuehrenTatbestandTableModel) || !(ziel.getModel() instanceof
	 * GebuehrenTatbestandTableModel)) return; GebuehrenTatbestandTableModel
	 * ausgangsModel = (GebuehrenTatbestandTableModel) ausgang.getModel();
	 * GebuehrenTatbestandTableModel zielModel = (GebuehrenTatbestandTableModel)
	 * ziel.getModel(); int selectedRow = ausgang.getSelectedRow();
	 */
}